Index: trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3570)
+++ trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3571)
@@ -8,11 +8,11 @@
 
 SUBROUTINE pemetat0(filename,ngrid,nsoil_PCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,icetable_depth,icetable_thickness, &
-                    ice_porefilling,tsurf_avg_yr1,tsurf_avg_yr2,q_co2,q_h2o,ps_inst,tsoil_inst,d_h2oice,d_co2ice,co2_ice,h2o_ice,    &
-                    global_avg_pressure,watersurf_avg,watersoil_avg,m_co2_regolith_phys,deltam_co2_regolith_phys,                    &
-                    m_h2o_regolith_phys,deltam_h2o_regolith_phys,stratif)
+                    ice_porefilling,tsurf_avg_yr1,tsurf_avg_yr2,q_co2,q_h2o,ps_timeseries,ps_avg_global,                           &
+                    watersurf_avg,watersoil_avg,m_co2_regolith_phys,deltam_co2_regolith_phys,                                      &
+                    d_h2oice,d_co2ice,co2_ice,h2o_ice,m_h2o_regolith_phys,deltam_h2o_regolith_phys,stratif)
 
 use iostart_PEM,                only: open_startphy, close_startphy, get_field, get_var, inquire_dimension, inquire_dimension_length
-use comsoil_h_PEM,              only: soil_pem, layer_PEM, mlayer_PEM, fluxgeo, inertiedat_PEM, ini_huge_h2oice, depth_breccia, depth_bedrock, index_breccia, index_bedrock
-use comsoil_h,                  only: volcapa, inertiedat
+use comsoil_h_PEM,              only: soil_pem, layer_PEM, fluxgeo, inertiedat_PEM, ini_huge_h2oice, depth_breccia, depth_bedrock, index_breccia, index_bedrock
+use comsoil_h,                  only: inertiedat
 use adsorption_mod,             only: regolith_adsorption, adsorption_pem
 use ice_table_mod,              only: computeice_table_equilibrium, icetable_equilibrium, icetable_dynamic
@@ -22,5 +22,4 @@
 use abort_pem_mod,              only: abort_pem
 use compute_soiltemp_mod,       only: ini_tsoil_pem, compute_tsoil_pem
-use comslope_mod,               only: def_slope_mean, subslope_dist
 use layering_mod,               only: layering, array2stratif, nb_str_max, layering_algo
 
@@ -36,47 +35,43 @@
 include "callkeys.h"
 
-character(*),                   intent(in) :: filename            ! name of the startfi_PEM.nc
-integer,                        intent(in) :: ngrid               ! # of physical grid points
-integer,                        intent(in) :: nsoil_PCM           ! # of vertical grid points in the PCM
-integer,                        intent(in) :: nsoil_PEM           ! # of vertical grid points in the PEM
-integer,                        intent(in) :: nslope              ! # of sub-grid slopes
-integer,                        intent(in) :: timelen             ! # time samples
-real,                           intent(in) :: timestep            ! time step [s]
-real,                           intent(in) :: global_avg_pressure ! mean average pressure on the planet [Pa]
-real, dimension(ngrid,nslope),  intent(in) :: tsurf_avg_yr1       ! surface temperature at the first year of PCM call [K]
-real, dimension(ngrid,nslope),  intent(in) :: tsurf_avg_yr2       ! surface temperature at the second year of PCM call [K]
-real, dimension(ngrid,timelen), intent(in) :: q_co2               ! MMR tracer co2 [kg/kg]
-real, dimension(ngrid,timelen), intent(in) :: q_h2o               ! MMR tracer h2o [kg/kg]
-real, dimension(ngrid,timelen), intent(in) :: ps_inst             ! surface pressure [Pa]
-real, dimension(ngrid,nslope),  intent(in) :: d_h2oice        ! tendencies on h2o ice
-real, dimension(ngrid,nslope),  intent(in) :: d_co2ice        ! tendencies on co2 ice
-real, dimension(ngrid,nslope),  intent(in) :: watersurf_avg       ! surface water ice density, yearly averaged (kg/m^3)
+character(*),                   intent(in) :: filename      ! name of the startfi_PEM.nc
+integer,                        intent(in) :: ngrid         ! # of physical grid points
+integer,                        intent(in) :: nsoil_PCM     ! # of vertical grid points in the PCM
+integer,                        intent(in) :: nsoil_PEM     ! # of vertical grid points in the PEM
+integer,                        intent(in) :: nslope        ! # of sub-grid slopes
+integer,                        intent(in) :: timelen       ! # time samples
+real,                           intent(in) :: timestep      ! time step [s]
+real,                           intent(in) :: ps_avg_global ! mean average pressure on the planet [Pa]
+real, dimension(ngrid,nslope),  intent(in) :: tsurf_avg_yr1 ! surface temperature at the first year of PCM call [K]
+real, dimension(ngrid,nslope),  intent(in) :: tsurf_avg_yr2 ! surface temperature at the second year of PCM call [K]
+real, dimension(ngrid,timelen), intent(in) :: q_co2         ! MMR tracer co2 [kg/kg]
+real, dimension(ngrid,timelen), intent(in) :: q_h2o         ! MMR tracer h2o [kg/kg]
+real, dimension(ngrid,timelen), intent(in) :: ps_timeseries ! surface pressure [Pa]
+real, dimension(ngrid,nslope),  intent(in) :: d_h2oice      ! tendencies on h2o ice
+real, dimension(ngrid,nslope),  intent(in) :: d_co2ice      ! tendencies on co2 ice
+real, dimension(ngrid,nslope),  intent(in) :: watersurf_avg ! surface water ice density, yearly averaged (kg/m^3)
 ! outputs
-real, dimension(ngrid),                          intent(out) :: deltam_co2_regolith_phys ! mass of co2 that is exchanged due to adsorption desorption [kg/m^2]
-real, dimension(ngrid),                          intent(out) :: deltam_h2o_regolith_phys ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
-real, dimension(ngrid,nslope),                   intent(out) :: h2o_ice                  ! h2o ice amount [kg/m^2]
-real, dimension(ngrid,nslope),                   intent(out) :: co2_ice                  ! co2 ice amount [kg/m^2]
-type(layering), dimension(ngrid,nslope),         intent(inout) :: stratif             ! stratification (layerings)
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: TI_PEM              ! soil (mid-layer) thermal inertia in the PEM grid [SI]
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: tsoil_PEM           ! soil (mid-layer) temperature [K]
-real, dimension(ngrid,nslope),                   intent(inout) :: icetable_depth      ! Ice table depth [m]
-real, dimension(ngrid,nslope),                   intent(inout) :: icetable_thickness  ! Ice table thickness [m]
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: ice_porefilling     ! Subsurface ice pore filling [m3/m3]
-real, dimension(ngrid,nsoil_PEM,nslope,timelen), intent(inout) :: tsoil_inst          ! instantaneous soil (mid-layer) temperature [K]
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: m_co2_regolith_phys ! mass of co2 adsorbed [kg/m^2]
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: m_h2o_regolith_phys ! mass of h2o adsorbed [kg/m^2]
-real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: watersoil_avg       ! surface water ice density, yearly averaged (kg/m^3)
+real, dimension(ngrid),                  intent(out) :: deltam_co2_regolith_phys ! mass of co2 that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid),                  intent(out) :: deltam_h2o_regolith_phys ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid,nslope),           intent(out) :: h2o_ice                  ! h2o ice amount [kg/m^2]
+real, dimension(ngrid,nslope),           intent(out) :: co2_ice                  ! co2 ice amount [kg/m^2]
+type(layering), dimension(ngrid,nslope), intent(inout) :: stratif             ! stratification (layerings)
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: TI_PEM              ! soil (mid-layer) thermal inertia in the PEM grid [SI]
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: tsoil_PEM           ! soil (mid-layer) temperature [K]
+real, dimension(ngrid,nslope),           intent(inout) :: icetable_depth      ! Ice table depth [m]
+real, dimension(ngrid,nslope),           intent(inout) :: icetable_thickness  ! Ice table thickness [m]
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: ice_porefilling     ! Subsurface ice pore filling [m3/m3]
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: m_co2_regolith_phys ! mass of co2 adsorbed [kg/m^2]
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: m_h2o_regolith_phys ! mass of h2o adsorbed [kg/m^2]
+real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: watersoil_avg       ! surface water ice density, yearly averaged (kg/m^3)
 ! local
-real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_startPEM                  ! soil temperature saved in the start [K]
-real, dimension(ngrid,nsoil_PEM,nslope) :: TI_startPEM                     ! soil thermal inertia saved in the start [SI]
-logical                                 :: found, found2                   ! check if variables are found in the start
-integer                                 :: iloop, ig, islope, it, isoil, k ! index for loops
-real                                    :: kcond                           ! Thermal conductivity, intermediate variable [SI]
-real                                    :: delta                           ! Depth of the interface regolith-breccia, breccia -bedrock [m]
-character(2)                            :: num                             ! intermediate string to read PEM start sloped variables
-real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_tmp_yr1                   ! intermediate soil temperature during yr 1 [K]
-real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_tmp_yr2                   ! intermediate soil temperature during yr 2 [K]
-logical                                 :: startpem_file                   ! boolean to check if we read the startfile or not
-real, dimension(:,:,:,:), allocatable   :: stratif_array                   ! Array for stratification (layerings)
+real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_startpem           ! soil temperature saved in the start [K]
+real, dimension(ngrid,nsoil_PEM,nslope) :: TI_startPEM              ! soil thermal inertia saved in the start [SI]
+logical                                 :: found, found2            ! check if variables are found in the start
+integer                                 :: iloop, ig, islope, isoil ! index for loops
+real                                    :: delta                    ! Depth of the interface regolith-breccia, breccia -bedrock [m]
+character(2)                            :: num                      ! intermediate string to read PEM start sloped variables
+logical                                 :: startpem_file            ! boolean to check if we read the startfile or not
+real, dimension(:,:,:,:), allocatable   :: stratif_array            ! Array for stratification (layerings)
 
 #ifdef CPP_STD
@@ -210,5 +205,5 @@
             else ! found
                 do iloop = nsoil_PCM + 1,nsoil_PEM
-                    TI_PEM(:,iloop,islope) = TI_startPEM(:,iloop,islope)  ! ! 1st layers can change because of the presence of ice at the surface, so we don't change it here.
+                    TI_PEM(:,iloop,islope) = TI_startPEM(:,iloop,islope) ! 1st layers can change because of the presence of ice at the surface, so we don't change it here.
                 enddo
             endif ! not found
@@ -258,7 +253,7 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !2. Soil Temperature
-        do islope=1,nslope
+        do islope = 1,nslope
             write(num,fmt='(i2.2)') islope
-            call get_field("tsoil_PEM_slope"//num,tsoil_startPEM(:,:,islope),found)
+            call get_field("tsoil_PEM_slope"//num,tsoil_startpem(:,:,islope),found)
             if (.not. found) then
                 write(*,*)'PEM settings: failed loading <tsoil_PEM_slope'//num//'>'
@@ -267,19 +262,15 @@
                 call compute_tsoil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr2(:,islope),tsoil_PEM(:,:,islope))
             else
-! predictor corrector: restart from year 1 of the PCM and build the evolution of tsoil at depth
-                tsoil_tmp_yr1(:,:,islope) = tsoil_startPEM(:,:,islope)
-                call compute_tsoil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
-                call compute_tsoil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
-                tsoil_tmp_yr2(:,:,islope) = tsoil_tmp_yr1(:,:,islope)
-                call compute_tsoil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr2(:,islope),tsoil_tmp_yr2(:,:,islope))
+! predictor-corrector: due to changes of surface temperature in the PCM, the tsoil_startpem is adapted firstly
+!                      for PCM year 1 and then for PCM year 2 in order to build the evolution of the profile at depth
+                call compute_tsoil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr1(:,islope),tsoil_startpem(:,:,islope))
+                call compute_tsoil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr1(:,islope),tsoil_startpem(:,:,islope))
+                call compute_tsoil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_avg_yr2(:,islope),tsoil_startpem(:,:,islope))
 
                 do iloop = nsoil_PCM + 1,nsoil_PEM
-                    tsoil_PEM(:,iloop,islope) = tsoil_tmp_yr2(:,iloop,islope)
+                    tsoil_PEM(:,iloop,islope) = tsoil_startpem(:,iloop,islope)
                 enddo
             endif !found
 
-            do it = 1,timelen
-                tsoil_inst(:,nsoil_PCM + 1:nsoil_PEM,islope,it) = tsoil_PEM(:,nsoil_PCM + 1:nsoil_PEM,islope)
-            enddo
             do isoil = nsoil_PCM + 1,nsoil_PEM
                 watersoil_avg(:,isoil,islope) = exp(beta_clap_h2o/tsoil_PEM(:,isoil,islope) + alpha_clap_h2o)/tsoil_PEM(:,isoil,islope)*mmol(igcm_h2o_vap)/(mugaz*r)
@@ -296,5 +287,5 @@
                 write(*,*)'will reconstruct the values of the ice table given the current state'
                 call computeice_table_equilibrium(ngrid,nslope,nsoil_PEM,watercaptag,watersurf_avg,watersoil_avg,TI_PEM(:,1,:),icetable_depth,icetable_thickness)
-                call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,global_avg_pressure,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
+                call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,ps_avg_global,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
                 do islope = 1,nslope
                     call ini_tsoil_pem(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_avg_yr2(:,islope),tsoil_PEM(:,:,islope))
@@ -309,5 +300,5 @@
                 write(*,*)'PEM settings: failed loading <icetable_depth>'
                 write(*,*)'will reconstruct the values of the ice table given the current state'
-                call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,global_avg_pressure,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
+                call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,ps_avg_global,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
                 do islope = 1,nslope
                     call ini_tsoil_pem(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_avg_yr2(:,islope),tsoil_PEM(:,:,islope))
@@ -328,5 +319,5 @@
                 endif
             enddo
-            do islope=1,nslope
+            do islope = 1,nslope
                 write(num,fmt='(i2.2)') islope
                 call get_field("mh2o_reg_ads_slope"//num,m_h2o_regolith_phys(:,:,islope),found2)
@@ -337,6 +328,6 @@
             enddo
 
-            call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,d_h2oice,d_co2ice,h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_inst,q_co2,q_h2o, &
-                                        m_h2o_regolith_phys,deltam_h2o_regolith_phys, m_co2_regolith_phys,deltam_co2_regolith_phys)
+            call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,d_h2oice,d_co2ice,h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_timeseries,q_co2,q_h2o, &
+                                     m_h2o_regolith_phys,deltam_h2o_regolith_phys,m_co2_regolith_phys,deltam_co2_regolith_phys)
 
             if (.not. found) deltam_co2_regolith_phys = 0.
@@ -441,16 +432,4 @@
 
 ! First raw initialization
-            do it = 1,timelen
-                do isoil = nsoil_PCM + 1,nsoil_PEM
-                    tsoil_inst(:,isoil,islope,it) = tsoil_PEM(:,isoil,islope)
-                enddo
-            enddo
-
-            do it = 1,timelen
-                do isoil = nsoil_PCM + 1,nsoil_PEM
-                    call ini_tsoil_pem(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_avg_yr2(:,islope),tsoil_inst(:,:,islope,it))
-                enddo
-            enddo
-
             do isoil = nsoil_PCM + 1,nsoil_PEM
                 do ig = 1,ngrid
@@ -465,5 +444,5 @@
         if (icetable_equilibrium) then
             call computeice_table_equilibrium(ngrid,nslope,nsoil_PEM,watercaptag,watersurf_avg,watersoil_avg,TI_PEM(:,1,:),icetable_depth,icetable_thickness)
-            call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,global_avg_pressure,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
+            call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,ps_avg_global,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
             do islope = 1,nslope
                 call ini_tsoil_pem(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_avg_yr2(:,islope),tsoil_PEM(:,:,islope))
@@ -471,5 +450,5 @@
             write(*,*) 'PEMETAT0: Ice table done'
         else if (icetable_dynamic) then
-            call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,global_avg_pressure,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
+            call update_soil_thermalproperties(ngrid,nslope,nsoil_PEM,d_h2oice,h2o_ice,ps_avg_global,icetable_depth,icetable_thickness,ice_porefilling,icetable_equilibrium,icetable_dynamic,TI_PEM)
             do islope = 1,nslope
                 call ini_tsoil_pem(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_avg_yr2(:,islope),tsoil_PEM(:,:,islope))
@@ -483,5 +462,5 @@
             m_co2_regolith_phys = 0.
             m_h2o_regolith_phys = 0.
-            call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,d_h2oice,d_co2ice,h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_inst,q_co2,q_h2o, &
+            call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,d_h2oice,d_co2ice,h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_timeseries,q_co2,q_h2o, &
                                      m_h2o_regolith_phys,deltam_h2o_regolith_phys, m_co2_regolith_phys,deltam_co2_regolith_phys)
             deltam_co2_regolith_phys = 0.
Index: trunk/LMDZ.COMMON/libf/evolution/pemredem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 3570)
+++ trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 3571)
@@ -77,6 +77,6 @@
 real, dimension(ngrid,nsoil_PEM,nslope), intent(in) :: tsoil_slope_PEM       ! under mesh bining according to slope
 real, dimension(ngrid,nsoil_PEM,nslope), intent(in) :: inertiesoil_slope_PEM ! under mesh bining according to slope
-real, dimension(ngrid,nslope),           intent(in) :: icetable_depth       ! under mesh bining according to slope
-real, dimension(ngrid,nslope),           intent(in) :: icetable_thickness   ! under mesh bining according to slope
+real, dimension(ngrid,nslope),           intent(in) :: icetable_depth        ! under mesh bining according to slope
+real, dimension(ngrid,nslope),           intent(in) :: icetable_thickness    ! under mesh bining according to slope
 real, dimension(ngrid,nsoil_PEM,nslope), intent(in) :: ice_porefilling       ! under mesh bining according to slope
 real, dimension(ngrid,nsoil_PEM,nslope), intent(in) :: m_co2_regolith, m_h2o_regolith
@@ -119,6 +119,6 @@
         call put_field("tsoil_PEM_slope"//num,"Soil temperature by slope type",tsoil_slope_PEM(:,:,islope),Year)
         call put_field("TI_PEM_slope"//num,"Soil Thermal Inertia by slope type",inertiesoil_slope_PEM(:,:,islope),Year)
-        call put_field("mco2_reg_ads_slope"//num, "Mass of co2 adsorbed in the regolith",m_co2_regolith(:,:,islope),Year)
-        call put_field("mh2o_reg_ads_slope"//num, "Mass of h2o adsorbed in the regolith",m_h2o_regolith(:,:,islope),Year)
+        call put_field("mco2_reg_ads_slope"//num, "Mass of CO2 adsorbed in the regolith",m_co2_regolith(:,:,islope),Year)
+        call put_field("mh2o_reg_ads_slope"//num, "Mass of H2O adsorbed in the regolith",m_h2o_regolith(:,:,islope),Year)
     enddo
     call put_field("icetable_depth","Depth of ice table",icetable_depth,Year)
